package graph.extractor.graph.builder;

import java.io.File;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import entity.DOProcess;
import graph.input.file.InputFactory;
import graph.output.OutPutFactory;

public abstract class BuilderFactory {

	protected List<DOProcess> processes;
	protected InputFactory input;

	public BuilderFactory(){
		this.processes = new ArrayList<DOProcess>();

	}

	public void cacheFilesToMemory(InputFactory input){
		this.input = input;
	}


	public void extractAllProcesses(OutPutFactory output){

		File DoFolder = input.getDOFolder();
		List<File> allDateFiles = new ArrayList<File>( input.getFilesFromDate(DoFolder));
		long originalSize = allDateFiles.size();
		
		
		while(allDateFiles.size() > 0)
		{
			try{
				Random rand = new Random();
				
				int randNumber = Math.abs(rand.nextInt(allDateFiles.size()));
				File oneDayOfDO = allDateFiles.get(randNumber);
				
				List<String> allProcess  = input.getAllProcess(oneDayOfDO);
				
				System.out.println("Processando dia "+oneDayOfDO.getName() + "---> " + allProcess.size() +" processos");
				System.out.println("Processados " +(originalSize - allDateFiles.size())+" de " + originalSize+" diarios");
				for(String oneProcess: allProcess)
				{
					DOProcess process = this.extractProcess(oneProcess);
					if(process != null)
					{
						process.setProcessDate(oneDayOfDO.getName());
						this.processes.add(process);
					}
				}
				output.buildOutput(this.processes);
				
				this.moveDoneFiles(oneDayOfDO);
				this.processes.clear();
				allProcess.clear();
				allDateFiles.remove(oneDayOfDO);
				
			}catch(Exception e)
			{
				e.printStackTrace();
			}
			
			System.out.println( "Completado " +(originalSize - allDateFiles.size())+" de " + originalSize +". Faltam "+ allDateFiles.size() +" Processos");
			System.out.println("\n\n\n\n");
			

		}

	/*	for(File oneDayOfDO : allDateFiles )
		{
			List<String> allProcess  = input.getAllProcess(oneDayOfDO);

			for(String oneProcess: allProcess)
			{
				DOProcess process = this.extractProcess(oneProcess);
				if(process != null)
				{
					process.setProcessDate(oneDayOfDO.getName());
					this.processes.add(process);	
				}
			}

			output.buildOutput(this.processes);
			this.processes.clear();
			allProcess.clear();
		}*/



	}

	private void moveDoneFiles(File oneDayOfDO) {
		
		try{
			
		
		List<File> files = input.getFilesFromDate(oneDayOfDO);
		
		
		
		for(File file: files)
		{
			File doneFolder = new File("/home/ailton/Monografia/done/"+file.getName());
			Files.move(file.toPath(), doneFolder.toPath());
			
		}}catch(Exception e)
		{
			e.printStackTrace();
		}
		
		
	}

	public List<DOProcess> getAllProcess()
	{
		return this.processes;
	}

	protected abstract DOProcess extractProcess(String process);



}
